      subroutine hec_dig_fit(ic,dig_slices,amp,max_tim)
c
c use digital filtering to find signal peak
c input:  dig_slices --> array of time slices to be fit
c output: amp        --> maximum adc from fit
c         max_tim    --> time of maximum (ns)
c
c
      implicit none
c
      include'hec_par.inc'      ! shared parameters
      include'hec_dig_sys.inc'  ! digital filtering system common
c
c local variables
c
      integer ic, i_t
      real dig_slices(mx_nslice_dig), amp, max_tim
c
c calculate the maximum adc (amplitude)
c
ccc
ccc        write(6,*) 'FIT ic, dig_weight_amp ',ic,
ccc     +             (dig_weight_amp(ic,i_t), i_t=1, 5)
ccc     
      amp = 0.
      max_tim = 0.
      do i_t = 1, nslice_dig
        amp = amp + (dig_weight_amp(ic,i_t)*dig_slices(i_t))
        max_tim = max_tim + (dig_weight_tim(ic,i_t)*dig_slices(i_t))
      enddo   
c
c calculate the time of maximum
c
      if (amp .ne. 0.) then
        max_tim = max_tim/amp
      else
        max_tim = 0.
      endif
c
      return
      end
