      subroutine hec_ini
c
c 03/12/96  ML  improve order of calls to allow proper hbook handling
c 11/03/97  ML  include user_card and hec_card routines.
c 02/05/97  ML  rewritten.  
c               user initialization now after system packages.
c 12/04/98  ML  offline and online initialization in separate routines
c
c system initialization routine
c
c  1- sys datacard (ffread) initialization
c  2- user datacard initialization
c  3- read datacards
c  4- data io initialization
c  5- hbook initialization
c  6- fill geometry correspondence tables
c
      implicit none
c
      include'hec_par.inc'      !shared parameters
      include'hec_datacard.inc' !datacard values
c
c datacard initialization
c
      call hec_card
c
c user datacard initialization
c
      call user_card
c
c read user datacards
c
      call ffgo
      close(unit=13)
      call hec_card_print
c
c data io initialization
c
      call hec_io_ini
c
c hbook initialization
c
      call hec_hbook_ini
c
c fill geometry correspondence tables and clear channels
c
      call hec_geo
c
      print *,' *** system initialization done'
c
      end

