      logical function hec_nextevt_epio_runh(irecbuf,iepbuf)
c
c quick pass to get run header info (and slices/adc numbers)
c
c
c   created: 29.04.97   Dugan O'Neil
c   modified: 10.97     
c
      implicit none
c
c geometry common
c
      include'hec_par.inc'
      include'hec_geo.inc'
      include'hec_datacard.inc'
      include'hec_epio.inc'
      include'hec_evth.inc'
      include'hec_online.inc'
      include'hec_runh.inc'
c
c set the maximum number of records to search for the first
c record containing an event header bank
c
      integer maxrecords
      parameter (maxrecords = 10)
c
c set the maximum number of banks expected in a record
c
      integer maxsubl
      parameter (maxsubl = 10)
c
c local variable declarations
c      
      integer i, ib, id, ierr, nw, len
      integer irecords, nbank, lenrec
c
      integer lbank(maxsubl)
      logical getmore
      logical b_runh, b_geoe
c
c dimension epio buffer arrays
c
      integer*2 irecbuf, iepbuf
      dimension irecbuf(lrecbuf), iepbuf(lepbuf)
c
c we are looking for 
c - the run header bank
c - the event header bank
c - the adc values bank
c start by assuming we have none
c
      b_runh = .false.
      b_geoe = .false.
c
c loop over all records, until a record starting with an
c event header bank is found
c
      irecords = 0
      getmore = .true.
      do while (irecords .lt.  maxrecords .and. getmore)
c
c call epio reading
c
ccc        call epread(in_typ(2), 1, nw, irecbuf, iepbuf, ierr)
        call epread(in_typ(2), 20, nw, irecbuf, iepbuf, ierr)
        call epfrd(in_typ(2), 11, nw, irecbuf, iepbuf, ierr)
c
c correct for bad run header in May 96
c
        if (irunpd .eq. 1 .and. irecbuf(3) .eq. id_runh) then
         irecbuf(1) = 14
         irecbuf(2) = irecbuf(1) - 2
        endif
c
ccc        call hec_dump_epio
c
        if (ierr .eq. 1) then
c
c end of file
c
          hec_nextevt_epio_runh = .false.
          eorflag = .true.
          print *, ' *** end of epio file reached'
          return
c
         elseif (ierr .ne. 0) then
c
c epread error
c
c check if online mode - if so return instead of stopping
c
           if ( onflag ) then
             hec_nextevt_epio_runh = .false.
             print *, ' *** epread error in hec_nextevt_epio_runh '
     +                , ierr, ' returning to event loop'
             return
           else
             print *, ' *** epread error in hec_nextevt_epio_runh',
     +                ierr
             stop
           endif
c
         else        
c
c count number of records read
c
           irecords = irecords + 1
c
c get first bank
c
           len = irecbuf(2)
c
ccc           print *,'*** len,lepbuf',len,lepbuf
c
           do i = 1, min(len + 1, lrecbuf)
             ibankbuf(i) = irecbuf(1 + i)
           enddo
c
c get id and pointer of first bank in record

           id = ibankbuf(2)
c
c if it is a run header bank, fill RUNH common
c
           if (id .eq. id_runh) then 			
             call hec_runh_epio
             hec_nextevt_epio_runh = .true.
c
c record starts with event header
c this is a proper event record
c
           elseif (id .eq. id_evth) then 
             getmore=.false.
           endif
         endif
       enddo
c
c check that we have found an event header, if not, stop
c
      if (irecords .ge. maxrecords) then
         if (onflag) then
           print *, ' *** no event record found in', 
     +                     ' hec_nextevt_epio_runh'
           return
         else
           print *, ' *** no event record found in ', 
     +                       ' hec_nextevt_epio_runh'
           stop
         endif
      endif
c
c find pointers to banks in event record
c
      getmore = .true.
      nbank = 0
      ipointep = 2
c        print *, ' *** in nextevt_epio_runh, find pointers'
      do while (nbank .lt. maxsubl .and. getmore)
c        print *, ' *** in nextevt_epio_runh, ipointep  = ', ipointep
        len = irecbuf(ipointep) 
c        print *, ' *** in nextevt_epio_runh, bank id   = ', 
c     +  irecbuf(ipointep - 1 + 2)
c        print *, ' *** in nextevt_epio_runh, len       = ', len
c     
        if (len .lt. 1) then
          if (onflag) then
            print *,' *** bad bank length in hec_nextevt_epio_runh', 
     +                       len
            return
          else
            print *,' *** bad bank length in hec_nextevt_epio_runh', 
     +                       len
            stop
          endif
        endif
c     
        len = len + 1
        nbank = nbank + 1
        lbank(nbank)= ipointep
        ipointep = ipointep + len
c
c make sure not to go past end of record
c fixes for particular run periods
c
         lenrec = irecbuf(1)
c         print *, ' *** in nextevt_epio_runh, lenrec    = ', lenrec
         if (irunpd .eq. 1 .or. irunpd .eq. 3) then
           if (ipointep .lt. lenrec - 1) then
             getmore = .true.
           else
             getmore = .false.
           endif
         else
           if (ipointep - 2 .lt. lenrec - 1) then
             getmore = .true.
           else
             getmore = .false.
           endif
         endif
       enddo
c
c for this event record, loop over banks and fill commons
c
c        print *, ' *** in nextevt_epio_runh, over banks'
      do ib = 1, nbank
c
c get pointer to the beginning of current bank
c
         ipointep = lbank(ib)
c
c get current bank
c
c        print *, ' *** in nextevt_epio_runh, ipointep  = ', ipointep
         len = irecbuf(ipointep)
c        print *, ' *** in nextevt_epio_runh, len       = ', len
         do i = 1, min(len + 1, lrecbuf)
           ibankbuf(i) = irecbuf(ipointep - 1 + i)
         enddo
c
c get bank id
c
         id = ibankbuf(2)
c        print *, ' *** in nextevt_epio_runh, bank id   = ', len
c
c get number of adcs and time slices for histogram booking
c
         if (id .eq. id_geoe_96 .or. id .eq. id_geoe_97) then
           if (i_adc_used .ne. ibankbuf(3)) then
             print *, 
     +       ' *** inconsistent number of adc in hec_nextevt_epio_runh',
     +       '  expected ', i_adc_used, 'read--> ', ibankbuf(3)
             i_adc_used = ibankbuf(3)
           endif
           if (irunpd .ge. 5) then
             if (i_tim_used .ne. ibankbuf(4)) then
               print *, 
     +         ' *** inconsistent number of time samplings in '//
     +         'hec_nextevt_epio_runh'//
     +         '  expected ', i_tim_used,'  read--> ', ibankbuf(4)
               i_tim_used = ibankbuf(4) 
             endif
           endif
           return
         endif
c
       enddo
c
       end
      








