      subroutine hec_his_book_ana
c
c book online histograms after event loop
c
      implicit none
c
      include'hec_par.inc'      !shared parameters
      include'hec_datacard.inc' !datacard values
      include'hec_geo.inc'      !geometry correspondence tables
      include'hec_his_sys.inc'  !histogram package
      include'hec_online.inc'   !online common
      include'hec_ped.inc'      !pedestal ids
      include'hec_runh.inc'     !run header common
c
c local variables
c
      integer ic, i_z
      character*70 ct
      character*4 c4
      character*1 cd
      real vmax
      real mxrms
      integer nbin, nbin_eta, nbin_phi
      integer id
c
c histo type 1 -- ped/noise histos
c
      if (histo_switch(1) .eq. 1) then
c
c adc pedestal values
c
        id = id_ped
        call hbook1(id, 'adc pedestals', 100, 500., 1500., 0.)
c
        id = id_ped_ic
        call hbook1(id, 'adc pedestals vs ic', i_adc_used, 
     +    0.5, i_adc_used + 0.5, 0.)
c
c adc pedestal rms values 
c
        nbin = 100
        mxrms = 
     +    real(max(100, 100*(int(vmax(adc_rms, i_adc_used)/100.) + 1)))
        id = id_rms
        call hbook1(id, 'adc pedestals rms', nbin, 0., mxrms, 0.)
c
        id = id_rms_ic
        call hbook1(id, 'adc pedestals rms vs ic', i_adc_used, 
     +    0.5, i_adc_used + 0.5, 0.)
      endif
c
c histo type 2 -- geometrical energy distribution
c
      if (histo_switch(2) .eq. 1) then
c
c maximum versus channel number
c
        nbin = i_adc_used
        ct = 'ave. adc(max) vs. channel number '
        id = id_max_ic
        call hbook1(id,ct,nbin,0.5,i_adc_used+0.5,0.)
c
c book lego map to find beam in each layer 
c
        nbin_eta = 6
        nbin_phi = 6
        id = id_map - 1
        do i_z = 1, i_z_used
          id = id + 1
          write(cd(1:1), '(i1)') i_z
          ct = 'Depth '//cd
          call hbook2(id, ct, nbin_phi, 0.5, real(nbin_phi)+0.5, 
     +                        nbin_eta, 0.5, real(nbin_eta)+0.5, 10000.)
        enddo
c
c book histos which show depth profile for each module
c
        nbin = i_z_used
        ct = 'adc(max) - ped depth profile for module 1 '
        id = id_adc_z + i_z_used + 1
        call hbook1(id, ct, nbin, 0., float(nbin), 0.)
        ct = 'adc(max) - ped depth profile for module 2 '
        id = id_adc_z + i_z_used + 2
        call hbook1(id, ct, nbin, 0., float(nbin), 0.)
        ct = 'adc(max) - ped depth profile for module 3 '
        id = id_adc_z + i_z_used + 3
        call hbook1(id, ct, nbin, 0., float(nbin), 0.)
c
      endif
c
c histo type 4 -- tdc corrected
c
      if (histo_switch(4) .eq. 1) then
c
c time profile in ns (including tdc) for each cell.
c number of bins is a parameter in hec_his_sys.inc
c
        do ic = 1, i_adc_used
          write(c4, '(i4)') ic
          ct = 'time + tdc (ns) for channel '//c4
          id = id_timns_ic + ic
          call hbook1(id, ct, i_tim_used*25, 0.,
     +                real(i_tim_used*25), 0.)
        enddo
      endif
c
c histo type 3 -- no tdc, no calibration correction
c
      if (histo_switch(3) .eq. 1) then
c
c time profile for each channel in 1997
c
        if (irunpd .ge. 4) then
          do ic = 1, i_adc_used
            write(c4, '(i4)') ic
            ct = 'time profile for channel '//c4
            id = id_tprof_ic + ic
            call hbook1(id,ct,i_tim_used,0.5,real(i_tim_used)+0.5,0.)
          enddo
        endif
c
      endif
c
      return
      end













