      subroutine hec_online_hisdispl(hisnum,high_ic,irunno,zoomstatus) 
c 
c This routine knows the required cosmetics for each 
c histogram number that is displayed. It's input is only the 
c histogram number, list of cell numbers of five highest energy 
c cells and the run number --- the output is what appears in the 
c graphical window.  
c
      implicit none
c
c histogram number include
c
      include'hec_par.inc'          ! shared parameters
      include'hec_datacard.inc'     ! datacard values
      include'hec_his_sys.inc'      ! online histogram ids
      include'hec_geo.inc'          ! geometry tables
c
      integer hisnum, high_ic(6), i_z, id
      character*1 cd
      character*7 ct
c
c declare integer and character version of run number
c
      integer irunno
      character*8 runno
c
c declare logical flags to determine if zoom function
c has been used, if new global title should be added to 
c histogram, and if a .ps file has been opened
c
      logical zoomflag, printflag, psflag, zoomstatus
c
      integer idh
c
c declare hbook function
c
      real hmax
      external hmax
c
c always keep id of histogram from last display call
c
      save idh
c
c initialize flags
c
      zoomflag = .false.
      printflag = .true.
      if (hisnum .lt. 0) psflag = .true. 
c
c when displaying plots
c we are only worried about the histo number, not about the sign
c
      hisnum = abs(hisnum)
c
c we need run number as a character variable, use internal write
c
      write(runno, '(i4)') irunno
c
c turn on statistics and fit
c
      call hplopt('STAT',1)
      call hplopt('FIT',1)
c
c Now begin an insanely long if statment. This set cosmetics
c for every available type of histogram
c
c
c adc pedestal distribution
c
      if (hisnum .eq. 1) then
        call hplopt('HTIT',1)
        call hplset('STAT',001111)
        call hplot(hisnum,' ',' ',0)
        call hplset('YHTI',1.2)        
c
c pedestal vs. channel number
c
      elseif (hisnum .eq. 2) then
        call hplopt('HTIT',1)
        call hplset('STAT',000001)
        call hplot(hisnum,' ',' ',0)
        call hplset('YHTI',1.2)        
c
c adc ped rms distribution
c
      elseif (hisnum .eq. 3) then
        call hplopt('HTIT',1)
        call hplset('STAT',100001)
        call hplot(3,' ',' ',0)
        call hplset('YHTI',1.2)        
c
c ped rms vs. channel number
c
      elseif (hisnum .eq. 4) then
        call hplopt('HTIT',1)
        call hplset('STAT',000001)
        call hplot(hisnum,' ',' ',0)
        call hplset('YHTI',1.2)        
c
c adcmax - ped vs. channel no.
c
      elseif (hisnum .eq. 5) then
        call hplopt('UTIT',1)
        call hplset('STAT',000001)
        call hplot(hisnum,' ',' ',0)
        call hpltit('ave. adcmax vs. ic')
        call hplset('YHTI',1.2)        
c
c lego plots showing deposit in each depth
c
      elseif (hisnum .ge. id_map .and. 
     +        hisnum .le. id_map - 1 + i_z_used) then
        call hplopt('UTIT',1)
        call hplset('STAT',000001)
        call hplset('NDVX',4.)
        call hplset('NDVY',6.)
        call hplot(hisnum,'LEGO1',' ',0)
        call hplax('phi','eta')
        write(cd(1:1), '(i1)') hisnum - id_map + 1
        ct='Depth '//cd
        call hpltit(ct)
        call hplset('YHTI',1.2)        
c
c reset divisions to default
c
        call hplset('NDVX',10510.)
        call hplset('NDVY',10510.)
c
c energy in each depth
c
      elseif (hisnum .eq. (id_adc_z+1)) then
        call hplopt('UTIT',1)
        call hplset('STAT',001111)
        call hplot(hisnum,' ',' ',0)
        call hpltit('ADCmax - ped in Depth 1')
        call hplset('YHTI',1.2)        
      elseif (hisnum .eq. (id_adc_z+2)) then
        call hplopt('UTIT',1)
        call hplset('STAT',001111)
        call hplot(hisnum,' ',' ',0)
        call hpltit('ADCmax - ped in Depth 2') 
        call hplset('YHTI',1.2)        
      elseif (hisnum .eq. (id_adc_z+3)) then
        call hplopt('UTIT',1)
        call hplset('STAT',001111)
        call hplot(hisnum,' ',' ',0)
        call hpltit('ADCmax - ped in Depth 3')
        call hplset('YHTI',1.2)        
      elseif (hisnum .eq. (id_adc_z+4)) then
        call hplopt('UTIT',1)
        call hplset('STAT',001111)
        call hplot(hisnum,' ',' ',0)
        call hpltit('ADCmax - ped in Depth 4')
        call hplset('YHTI',1.2)        
c
c depth profile for each module
c
      elseif (hisnum .eq. (id_adc_z+i_z_used+1)) then
        call hplopt('UTIT',1)
        call hplset('STAT',000001)
        call hplset('NDVX',3.)
        call hplot(hisnum,' ',' ',0)
        call hpltit('Energy Depth Profile of Module 1')
        call hplset('NDVX',10510.)
        call hplset('NDVY',10510.)
        call hplset('YHTI',1.2)        
      elseif (hisnum .eq. (id_adc_z+i_z_used+2)) then
        call hplopt('UTIT',1)
        call hplset('STAT',000001)
        call hplset('NDVX',3.)
        call hplot(hisnum,' ',' ',0)
        call hpltit('Energy Depth Profile of Module 2')
        call hplset('NDVX',10510.)
        call hplset('NDVY',10510.)
        call hplset('YHTI',1.2)        
      elseif (hisnum .eq. (id_adc_z+i_z_used+3)) then
        call hplopt('UTIT',1)
        call hplset('STAT',000001)
        call hplset('NDVX',3.)
        call hplot(hisnum,' ',' ',0)
        call hpltit('Energy Depth Profile of Module 3')
        call hplset('NDVX',10510.)
        call hplset('NDVY',10510.)
        call hplset('YHTI',1.2)        
c
c TDC distribution
c
      elseif (hisnum .eq. id_tdcd) then
        call hplopt('UTIT',1)
        call hplset('STAT',001111)
        call hplot(id_tdcd,' ',' ',0)
        call hpltit('TDC distribution (ns)')
c
c adcmax - ped for each channel
c
        call hplset('YHTI',1.2)        
      elseif (hisnum .gt. id_adc_ic .and. hisnum 
     +       .lt. (id_adc_ic + 1000)) then
        call hplopt('HTIT',1)
        call hplset('STAT',1111111)
        call hplot(hisnum,' ',' ',0)
        call hplset('YHTI',1.2)        
c
c time max for each channel
c
      elseif (hisnum .gt. id_tim_ic .and. hisnum 
     +       .lt. (id_tim_ic + 500)) then
        call hplopt('HTIT',1)
        call hplset('STAT',001111)
        call hplot(hisnum,' ',' ',0)
c
c beam chamber histos
c
      elseif (hisnum .gt. 5200 .and. hisnum 
     +       .lt. (5300)) then
        call hplopt('HTIT',1)
        call hplset('STAT',001111)
        call hplot(hisnum,' ',' ',0)
        call hplset('YHTI',1.2)        
c
c time profile in sample number for each channel
c
      elseif (hisnum .gt. id_tprof_ic .and. hisnum 
     +       .lt. (id_tprof_ic + 1000)) then
        call hplopt('HTIT',1)
        call hplset('STAT',000001)
        call hplset('NDVX',16.)
        call hplot(hisnum,' ',' ',0)
        call hplset('NDVX',10510.)
        call hplset('NDVY',10510.)
        call hplset('YHTI',1.2)        
c
c time profile in ns (using TDC) for each channel
c
      elseif (hisnum .gt. id_timns_ic .and. hisnum 
     +       .lt. (id_timns_ic + 1000)) then
        call hplopt('HTIT',1)
        call hplset('STAT',000001)
        call hplot(hisnum,' ',' ',0)
c
c calibrated energy for each channel
c
      elseif (hisnum .gt. id_cal_ic .and. hisnum 
     +       .lt. (id_cal_ic + 1000)) then
        call hplopt('HTIT',1)
        call hplset('STAT',001111)
        call hplot(hisnum,' ',' ',0)
        call hplset('YHTI',1.2)        
c
c energy in all calo cells above n*sigma
c
      elseif (hisnum .ge. id_sigma .and. hisnum .le. 
     +  (id_sigma+3)) then
        call hplopt('HTIT',1)
        call hplset('STAT',001111)
        call hplot(hisnum,' ',' ',0)
        call hplset('YHTI',1.2)        
c
c muon towers
c
c      elseif (hisnum .ge. id_muon_tower .and. hisnum .le. 
c     +  (id_muon_tower + 100)) then
c        call hplopt('HTIT',1)
c        call hplset('STAT',1111111)
c        call hplot(hisnum,' ',' ',0)
c        call hplset('YHTI',1.2)        
c
c list available histos
c
      elseif (hisnum .eq. 9999) then
        call hec_online_menu
c
c noise summary
c
      elseif (hisnum .eq. 9990) then
        call hplopt('HTIT',1)
        call hplset('STAT',000001)
        call hplzon(1,2,1,' ')
        call hplot(2,' ',' ',0)
        call hplot(4,' ',' ',0)
        call hplset('YHTI',1.2)        
c
c shape/time summary
c
      elseif (hisnum .eq. 9991) then
        call hplopt('HTIT',1)
        call hplset('STAT',000001)
        call hplzon(2,2,1,' ')
        call hplset('NDVX',16.)
        call hplot(id_tprof_ic+high_ic(1),' ',' ',0)
        call hplset('NDVX',10510.)
        call hplset('NDVY',10510.)
        call hplot(id_timns_ic+high_ic(1),' ',' ',0)
        call hplot(id_tim_ic+high_ic(1),' ',' ',0)
ccc        call hplot(id_tim_icns+high_ic(1),' ',' ',0)
        call hplot(id_tdcd,' ',' ',0)

c
c energy profile
c
      elseif (hisnum .eq. 9992) then
        call hplzon(2,2,1,' ')
        call hplopt('NSTA',1)
        call hplopt('UTIT',1)
        call hplset('NDVX',4.)
        call hplset('NDVY',6.)
c
        id = id_map - 1
        do i_z = 1, i_z_used
          write(cd(1:1), '(i1)') i_z
          ct='Depth '//cd
          id = id + 1
          call hplot(id,'LEGO1',' ',0)
          call hplax('phi','eta')
          call hpltit(ct)
        enddo
c
c reset divisions to default
c
        call hplset('NDVX',10510.)
        call hplset('NDVY',10510.)
        call hplset('STAT',001111)
        call hplopt('STAT',1)
c
        if(i_z_used.lt.4)then
          call hplot(id_sigma+3,' ',' ',0)
          call hpltit('Total energy: cells above 3 sigma')
        endif
c
c energy distributions
c
      elseif (hisnum .eq. 9993) then
        call hplopt('STAT',1)
        call hplset('STAT',001111)
        call hplopt('HTIT',1)
        call hplzon(2,2,1,' ')
c
        call hplot(id_adc_ic+high_ic(1),' ',' ',0)
        call hplot(id_adc_ic+high_ic(2),' ',' ',0)
        call hplot(id_adc_ic+high_ic(3),' ',' ',0)
        call hplot(id_adc_ic+high_ic(4),' ',' ',0)
        call hplset('YHTI',1.2)        
c
c beam chamber summaries
c
      elseif (hisnum .eq. 9994) then
        call hplopt('STAT',1)
        call hplset('STAT',001111)
        call hplopt('HTIT',1)
        call hplzon(2,2,1,' ')
        call hplot(5202,' ',' ',0)
        call hplot(5203,' ',' ',0)
        call hplot(5204,' ',' ',0)
        call hplot(5205,' ',' ',0)
      elseif (hisnum .eq. 9995) then
        call hplopt('STAT',1)
        call hplset('STAT',001111)
        call hplopt('HTIT',1)
        call hplzon(2,2,1,' ')
        call hplot(5207,' ',' ',0)
        call hplot(5208,' ',' ',0)
        call hplot(5209,' ',' ',0)
        call hplot(5210,' ',' ',0)
        call hplset('YHTI',1.2)     
c
c cluster summary
c   
      elseif (hisnum .eq. 9996) then
        call hplopt('STAT',1)
        call hplset('STAT',001111)
        call hplopt('HTIT',1)
        call hplzon(1,2,1,' ')
        call hplset('FIT',101)
        call hplset('SMGU',0.1)
        call hplopt('HTIT',1)
        call hplot(high_ic(6),' ',' ',0)
        call hplax('adc',' ')
c
c add energy axis
c
        call hec_online_clus_axis(high_ic(6))
c
        call hplot(high_ic(6)+1,' ',' ',0)
        call hplax('adc',' ')
c
c add energy axis
c
        call hec_online_clus_axis(high_ic(6)+1)
c
c reset everything when done
c
        call hplset('SMGU',0.)
c
c zoom on currently displayed histogram
c
      elseif (hisnum .eq. 9900) then
        print *,' '
        print *,'To Zoom on current plot, click the left mouse',
     +          ' button on the on each edge of the range you wish',
     +          ' to view.'
        print *,' '
        print *,'To exit Zoom, click the right mouse button on the',
     +          ' histogram window.'
        print *,' '
c
        call hec_online_hiszoom(zoomflag,idh)
        if (.not. zoomflag) printflag = .false.
c
c reset histo number to zoomed value
c
        hisnum = idh
c
c cluster histograms
c        
      elseif (hisnum .ge. 15000 .and. hisnum .le. 15200) then
        call hplopt('STAT',1)
        call hplopt('FIT',1)
        call hplset('STAT',001111)
        call hplset('FIT',101)
        call hplset('SMGU',0.1)
        call hplopt('HTIT',1)
        call hplot(hisnum,' ',' ',0)
        call hplax('adc',' ')
c
c put second axis on plot
c
        call hec_online_clus_axis(hisnum)
c
c reset
c
        call hplset('SMGU',0.)
      else
        call hplopt('HTIT',1)
        call hplot(hisnum,' ',' ',0)
      endif 
c
c put run number on the top of every plot
c draw text using hplot routine
c hplsof(xcm,ycm,txt,size,angle,dummy,left adjusted)
c
      if (printflag) then
        call hplsof(7.5,18.5,runno,1.,0.,0.,-1.)
      endif
c
 999  continue
      return
      end
