      subroutine hec_online_hisview
c
c allow viewing of online histogram files in higz window
c
      implicit none
c
      include'hec_par.inc'       ! shared parameters
      include'hec_paw.inc'       ! paw common
      include'hec_geo.inc'       ! geometry correspondence tables
      include'hec_online.inc'    ! online common
      include'hec_runh.inc'      ! run header common
      include'hec_datacard.inc'  ! datacard values
      include'hec_his_sys.inc'   ! online histogram numbers
c
c local variables
c
      logical zoomstatus
      integer hisnum, sig_index(i_adc_dim),ic,high_ic(6)
c
c declare hbook functions
c
      real hmax,hstati
      external hmax,hstati
c
      call hplint(1)
      call hplopt('STAT',1)
c
      hisnum = -1
      zoomstatus = .false.
c
c use cernlib sorting routine to find highest energy cells
c write ic of 5 highest energy cells to a text file if we are in 
c script controlled "autorun" mode. This is necessary in case 
c we need the info (highest cells) outside this program. For
c example, in a script we might call a program which reads online 
c histograms from online.hbook without calling hec_adc again.
c
c also, write out histogram number of highest energy cluster
c
c
      call sortzv(average_max,sig_index,i_adc_used,1,1,0)
      if (auto_run .eq. 1) then
        open(35,file="highcell.list",status="NEW")
        write(35, *) run_no
        write(35, '(5i3)') (sig_index(ic), ic = 1, 5)
        write(35,*) clusmax_histo_numb
        close(35)
      endif
c
c copy five highest cells to special array for use in choosing 
c histograms, also use this array to pass number of maximum cluster
c (sorry, this is not so nice....)
c
      do ic = 1, 5
        high_ic(ic) = sig_index(ic)
      enddo
      high_ic(6) = clusmax_histo_numb
c
c start with a zone 1 2 noise plot
c igmeta(0,0) makes sure that any output to .ps file, etc. is 
c turned off
c hec_online_hisdispl knows how to plot any histogram (cosmetics etc.)
c
      call igmeta(0,0)
c      call hec_online_hisdispl(9990,high_ic,int(run_no),zoomstatus)
      call iuwk(0,1)
      call igterm
c
c fill the run summary postscript file
c igmeta(-15,-111) sets logical unit 15 to postscript format
c
      open(unit=15,file='run_summary.ps',form='formatted',
     +     status='unknown')
      call igmeta(-15,-111)
      call hec_online_hisdispl(9996,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9990,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9991,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9992,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9993,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9994,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9995,high_ic,run_no,zoomstatus)
c
      call igmeta(999,0)
      close(15)
c
c list histogram menu
c
      call hec_online_menu
      if (.not. calo_on_flag) then
        print *,' '
        print *,'WARNING!!!: no ADCs read for this run,'
     +         ,'            most histograms not available'
        print *,' '
      endif
c
c open user summary ps file
c
      open(unit=10,file='user_summary.ps',form='formatted',
     +status='unknown')
c
c loop over user histogram choices until they choose histogram 0
c
      call hec_online_hisloop(high_ic,run_no)
c
      return
      end




