      subroutine hec_online_interface
c
c provides online interface in "autorun" mode
c never called from regular hec_adc package
c
c This routine opens and existing hbook file
c full of online histograms and gives the user 
c access to them in the same style as regular 
c online running.
c
c The only include files which are used contain
c parameters and histogram ids....this routine 
c does not depend on any stored values in common 
c blocks, thereby making it pseudo-independent from 
c hec_adc. 
c It is currently called from a program
c in the onlinescr directory and is used only on shift 
c at testbeam.
c
      implicit none
c
c online histogram common and parameter common
c This is shared with normal online running mode
c
      include'hec_par.inc'           ! shared parameters
      include'hec_his_sys.inc'       ! online histogram ids
c
c local variables
c
      integer maxcell
      parameter (maxcell=6)
      integer high_ic(maxcell),ic
      integer istat
c
      integer run_number
c
      logical zoomstatus
c
c access existing hbook file
c
      call hropen(35, 'hec_online', 
     +  'hec_online.hbook', ' ', 1024, istat)
      if (istat .ne. 0) then
        print *, '*** problem opening online hbook file ***',
     +  istat
        stop
      endif
c
c read histograms into memory
c
      call hcdir('//hec_online',' ')
      call hrin(0,0,0)
c
c initialize HPLOT graphical environment (for X11)
c
      call hplint(1)
c
c get list of 5 highest energy cells
c
      open(40,file="highcell.list",status="OLD")
      read(40, *) run_number
      read(40, '(1x,5i3)') (high_ic(ic), ic = 1, 5)
      read(40,*) high_ic(6)
      close(40)      
c
c start with a zone 1 2 noise plot
c
      call igmeta(0,0)
      call hec_online_hisdispl(9990,high_ic,run_number,zoomstatus)
      call iuwk(0,1)
      call igterm
c
c list histogram menu
c
      call hec_online_menu
c
c open user summary ps file
c
      open(unit=10,file='user_summary.ps',form='formatted',
     +status='unknown')
c
      call hplint(1)
      call hplopt('STAT',1)
c
      call hec_online_hisloop(high_ic,run_number)
c
c close hbook file
c
      call hrend('hec_online')
      call hdelet(0)
      close(35)
c
      return
      end
