      subroutine user_ini
c
c user initialization
c
c this example user_ini routine does the following:
c - open a user hbook file
c - book one ntuple
c - initialises user variables
c - prints the picked channel, in all three systems
c
      implicit none
c
c shared parameters common
c general constants
c please read the comment in the *.inc file
c
      include'hec_par.inc'
c
c user datacard values common
c this is where the user datacard values endup after the 
c initialisation phase has read the datacards
c please read the comment in the *.inc file
c
      include'user_datacard.inc'
c
c geometry correspondence tables common (requires hec_par.inc)
c this is an important file, with lots of important comments on
c the adc channel addressing schemes.
c must be preceded by the include file hec_par.inc
c please read the comment in the *.inc file
c
      include'hec_geo.inc'
c
c user internal variables common
c this is where are the variables used to compute the pedestal
c variance between the picked channel and the one above in eta
c
      include'user_common.inc'
c 
c local variable declarations
c
      integer istat
      character*6 cvar(4)
      data cvar/'sigic', 'sigdb', 'sigph', 'sigcl'/
c
c dump the geometry correspondence tables
c
      call hec_dump_geo
c
c open user hbook file
c
      call hropen(30, 'user', 'user.hbook', 'n', 1024, istat)
c
c book ntuples
c
      call hbookn(1, ' example ntuple', 4, '//user', 2000, cvar)
c      
c initialize user internal variables common
c
      m_0    = 0
      dm_1a  = 0.d0
      dm_1b  = 0.d0
      dm_2ab = 0.d0
c
c print the user picked adc channel
c
      print *, ' '
      print *, ' user picked channel'
c ic system
      print *, ' ic system'
      print *, ' ic    = ', ic_pick
c database system
      print *, ' database system'
      print *, ' i_mod = ', ictodb(ic_pick, 1)
      print *, ' i_seg = ', ictodb(ic_pick, 2)
      print *, ' i_pad = ', ictodb(ic_pick, 3)
c physics
      print *, ' physics system'
      print *, ' i_eta = ', ictoph(ic_pick, 1)
      print *, ' i_phi = ', ictoph(ic_pick, 2)
      print *, ' i_z   = ', ictoph(ic_pick, 3)
      print *, ' '
c
      print *, ' *** user initialization done'
c
      end
